package yrpg.yrpgapp.crmvisit.plugin.crm;

import kd.bos.bill.AbstractMobBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.form.control.events.WaterMarkEvent;
import kd.bos.form.control.events.WaterMarkListener;
import kd.bos.form.field.PictureEdit;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;

/**
 * 动态表单插件
 */
public class PictureWaterMarkMobBillPlugin extends AbstractMobBillPlugIn implements WaterMarkListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        PictureEdit signInImg1 = this.getControl("yrpg_sign_in_img_1");
        signInImg1.addWaterMarkListener(this);

        PictureEdit signInImg2 = this.getControl("yrpg_sign_in_img_2");
        signInImg2.addWaterMarkListener(this);

        PictureEdit signOutImg1 = this.getControl("yrpg_sign_out_img_1");
        signOutImg1.addWaterMarkListener(this);

        PictureEdit signOutImg2 = this.getControl("yrpg_sign_out_img_2");
        signOutImg2.addWaterMarkListener(this);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //开启图片添加水印功能
        PictureEdit signInImg1 = this.getControl("yrpg_sign_in_img_1");
        signInImg1.setShowWaterMark(true);

        PictureEdit signInImg2 = this.getControl("yrpg_sign_in_img_2");
        signInImg2.setShowWaterMark(true);

        PictureEdit signOutImg1 = this.getControl("yrpg_sign_out_img_1");
        signOutImg1.setShowWaterMark(true);

        PictureEdit signOutImg2 = this.getControl("yrpg_sign_out_img_2");
        signOutImg2.setShowWaterMark(true);
    }


    @Override
    public void getWaterMarkInfos(WaterMarkEvent evt) {
        WaterMarkListener.super.getWaterMarkInfos(evt);
        DynamicObject creator = (DynamicObject)this.getModel().getValue("creator");
        Object img = this.getModel().getValue("yrpg_sign_in_img_1");
        System.out.println(img);

        String name = creator.get("name").toString();
        String number = creator.get("number").toString();


        String address = this.getModel().getValue("yrpg_sign_in_address").toString();


        evt.getMap().put("mainInfo", name + "," + number);
        evt.getMap().put("subInfo", splitString(address, 15));
    }

    @Override
    public void uploadFile(EventObject e) throws UnsupportedOperationException {
        super.uploadFile(e);

        System.out.println(e);
    }

    public static List<String> splitString(String str, int chunkSize) {
        List<String> chunks = new ArrayList<>();

        for (int i = 0; i < str.length(); i += chunkSize) {
            if (i + chunkSize > str.length()) {
                chunks.add(str.substring(i));
            } else {
                chunks.add(str.substring(i, i + chunkSize));
            }
        }

        return chunks;
    }
}